unit Sou_Main;

{Dieses Projekt demonstriert die Ausgabe eines Sinustones ber
 die direkte Ansteuerung des PC-Speakers

 Das Projekt funktioniert aufgrund der direkten Portzugriffe
 nicht unter Win NT.}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TMainForm = class(TForm)
    BtnSound: TButton;
    BtnNoSound: TButton;
    SpinFreq: TSpinEdit;
    Label1: TLabel;
    procedure BtnSoundClick(Sender: TObject);
    procedure BtnNoSoundClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

function InPort(PortAddr:word): byte; assembler; stdcall;
asm
  mov dx,PortAddr
  in al,dx
end;

procedure OutPort(PortAddr: word; Databyte: byte); assembler; stdcall;
asm
  mov al,Databyte
  mov dx,PortAddr
  out dx,al
end;

Procedure Sound(Hz : Word);
var TmpW : Word;
begin
  OutPort($43,182);
  TmpW :=InPort($61);
  OutPort($61,TmpW or 3);
  OutPort($42,lo(1193180 div hz));
  OutPort($42, hi(1193180 div hz));
end;

Procedure NoSound;
var TmpW : Word;
begin
  OutPort($43,182);
  TmpW := InPort($61);
  OutPort($61,TmpW and 3);
end;

procedure TMainForm.BtnSoundClick(Sender: TObject);
begin
  Sound(SpinFreq.Value);
end;

procedure TMainForm.BtnNoSoundClick(Sender: TObject);
begin
  NoSound;
end;

end.
